package javax.lang.model.element;

import java.lang.annotation.Annotation;
import java.util.List;
import java.util.Set;
import javax.lang.model.type.TypeMirror;
import javax.lang.model.AnnotatedConstruct;

public interface Element extends AnnotatedConstruct
{
    public abstract TypeMirror asType();
    
    public abstract ElementKind getKind();
    
    public abstract Set<Modifier> getModifiers();
    
    public abstract Name getSimpleName();
    
    public abstract Element getEnclosingElement();
    
    public abstract List<? extends Element> getEnclosedElements();
    
    public abstract boolean equals(Object p0);
    
    public abstract int hashCode();
    
    public abstract List<? extends AnnotationMirror> getAnnotationMirrors();
    
    public abstract <A extends Annotation> A getAnnotation(Class<A> p0);
    
    public abstract <R, P> R accept(ElementVisitor<R, P> p0, P p1);
}
